<?php
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsPrice extends JPlugin
{
	function plgJoomsuite_content_fieldsPrice( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if($type != 'price') return;
		global $mainframe;

		$db = &JFactory::getDBO();
		$def = JRequest::getVar('fields', null, 'default', 'array');

		if($def[$obj->id]) $obj->field_value = $def[$obj->id];
		if(!$params->get('section_id'))
		{
			echo JText::_('This field settings will be available after Sourse Section is selected in field plugin configuration');
			return;
		}
		$secid = ($obj->record_id) ? ResHelper::getArticleSection($obj->record_id) : $params->get('section_id');
		$CP = ResHelper::getSectionParams($secid);

		$if_commerce_exists = JPATH_ROOT.DS.'administrator/components/com_commerce/controllers'.DS.'config.php';
		if(!file_exists($if_commerce_exists))
		{
			echo '<b>This field works only if <a href="http://www.mightyextensions.com/joomla-components/commerce-mall-b2b-b2c-c2c-private-shop" target="_blank">Mighty Commerce</a> is installed</b>';
			return;
		}

		if(isset($CP) && !$CP->get('comm_enabled'))
		{
			echo JText::_('Selected Sourse section is not Commercial. Please resave field plugin configurations or set up Commerce configurations in selected Section');
			return;
		}
		$query = " SELECT c.id, c.name, c.code, IF(c.mark != '', c.mark, c.code) as mark
				FROM #__jc_currency c WHERE c.id = '".$CP->get('comm_core_currency')."'";
		$db->setQuery( $query);
		$core = $db->loadObject();

		$price = $obj->field_value;
		$query = " SELECT user_id FROM #__js_res_record WHERE id='{$obj->record_id}'";
		$db->setQuery( $query);
		$uid = $db->loadResult();
		if(!$uid){
			$user   =& JFactory::getUser();
			$uid = $user->get('id');
		}

		$out = '';
		$sql = "SELECT value FROM #__js_res_field_extra WHERE field_id = '{$obj->id}' AND record_id = '{$obj->record_id}' AND ref_id = 'price_ext'";
		$db->setQuery($sql);
		if($extra = $db->loadResult())
		{
			$val = unserialize($extra);
		}

		if($params->get('predefined', 0))
		{
			if($params->get('pricelist', '') != '')
			{
				$list = explode("\n", $params->get('pricelist'));
				$opt = array();
				$opt[] = JHTML::_('select.option', '', '- '.JText::_('Select price from list').' -');
				foreach($list as $value)
				{
					$opt[] = JHTML::_('select.option', $value, str_replace(array("00", "Sign"), array($value, $core->mark), $CP->get('comm_layout_price')));
				}
				$out .= JHTML::_('select.genericlist',  $opt, "fields[".$obj->id."]", 'class="inputbox"', 'value', 'text', $obj->field_value);
				$out .= '<input type="hidden" name="currency_id-'.$obj->id.'" value="'.$CP->get('comm_core_currency').'">';
			}
			else
			$out = '<b>'.JText::_('Price list is not set').'</b>';
		}
		else
		{

			if(isset($val['currency_id']) && $CP->get('comm_core_currency') != $val['currency_id'])
			$this->convertPrice($price, $val['currency_id'], 'from_core', $CP->get('comm_core_currency'), $secid);
			
			$price = round($price, 2);


			$query = " SELECT DISTINCT(c.id), c.name, c.code, IF(c.mark != '', c.mark, c.code) as mark
			FROM #__jc_currency  AS c
			LEFT JOIN #__jc_users_currencies AS u ON c.id = u.currency_id
			WHERE u.published = '1' ".( $CP->get('comm_multi_seller') ? "AND u.seller_id = '$uid'" : "")."
			AND u.section_id = '$secid'
			ORDER BY c.id DESC, c.name ASC";
			$db->setQuery( $query);

			$rows = $db->loadObjectList();
			$c = array();
			$c[] = JHTML::_('select.option', $CP->get('comm_core_currency'), "($core->code) ".$core->name);
			if(count($rows))
			{
				foreach($rows as $row)
				{
					$c[] = JHTML::_('select.option', $row->id, "($row->code) ".$row->name);
				}
			}
			$currency_id = isset($val['currency_id']) ? $val['currency_id'] : '';
			$currency = JHTML::_('select.genericlist', $c, 'currency_id-'.$obj->id, 'class="inputbox"', 'value', 'text', $currency_id );

			$out .= '<input	type="text" size="8" name="fields['.$obj->id.']" id="fields-'.$obj->id.'" value="'.$price.'"
			onKeyUp="formatFloat(\'fields-'.$obj->id.'\)" maxlength="10" />';
			$out .= $currency;
		}

		$taxes = '';
		if($params->get('use_tax'))
		{
			$query = " SELECT t.id, t.name, t.rate
				FROM #__jc_taxes  AS t
				WHERE t.published='1' ".( $CP->get('comm_multi_seller') ? "AND t.seller_id = '$uid'" : "")."
			AND t.section_id = '$secid'
			ORDER BY t.id DESC, t.name ASC";
			$db->setQuery( $query);
			$rows = $db->loadObjectList();
			$t = array();
			$t[] = JHTML::_('select.option', 0, "- ".JText::_("select tax from list")." -");
			if(count($rows))
			{
				foreach($rows as $row)
				{
					$t[] = JHTML::_('select.option', $row->id, "($row->rate%) ".$row->name);
				}
			}
			$tax_id = isset($val['tax_id']) ? $val['tax_id'] : '';
			$taxes =   JHTML::_('select.genericlist', $t, 'tax_id-'.$obj->id, 'class="inputbox"', 'value', 'text', $tax_id );
		}
		$out .= $taxes;

		$price_extra = (isset($val['extra']) ? $val['extra'] : array());
		if ($params->get('allow_extra', 0))
		{
			$i = 0;
			$extra_out = '<h3>'.JText::_('Additional prices').'</h3>';
			$extra_out .= '
			<table cellpadding="2" cellspacing="0" border="0" width="'.($mainframe->isAdmin() ? '50%':  '100%').'">
				<tbody id="extra-'. $obj->id.'">
					<tr class="sectiontableheader"'.($mainframe->isAdmin() ? ' bgcolor="#444444" style="color: #fff;"' : '').'>
						<td class="sectiontableheader" width="40%">'.JText::_('Title').'</td>
						<td class="sectiontableheader" width="20%" nowrap>'.JText::_('Min Amount').'</td>
						<td class="sectiontableheader" width="30%">'.JText::_('Price per 1 item').'</td>
						<td class="sectiontableheader" width="10%">&nbsp;</td>
					</tr>';
			if(count($price_extra))
			{
				foreach ($price_extra['price'] as $k => $pr_ex)
				{
					if($params->get('max_extra') && $k > $params->get('max_extra')) break;
					if($price_extra['title'][$k] == '' || $price_extra['min_amount'][$k] == '' || $price_extra['price'][$k] == '') continue;
					$extra_out .= '
							<tr id="option'.$k.'">
							<td><input type="text" name="extra['.$obj->id.'][title]['.$i.']" style="width: 95%;"
							value="'.$price_extra['title'][$k].'" class="inputbox"/>
							</td>
							<td><input type="text" name="extra['.$obj->id.'][min_amount]['.$i.']"  size="5"
							id="extra'.$obj->id.'_amount'.$i.']" onkeyUp="formatInt(this.id)"
							value="'.$price_extra['min_amount'][$k].'" class="inputbox"/>
							</td>
							<td><input type="text" name="extra['.$obj->id.'][price]['.$i.']" size="15"
							id="extra'.$obj->id.'_price'.$i.']" onkeyUp="formatFloat(this.id)" class="inputbox"
							value="'.$pr_ex.'"/>
							</td>
							<td><a href="javascript:void(0);"
							onclick="removeItem('.$obj->id.', '.$k.');">Remove</a>
							</td>
							</tr>';
					$i ++;
				}
			}
			$extra_out .= '
					</tbody>	
				</table><br>';
			$extra_out .= '
			 	<a href="javascript: void(0);" onclick="addNew('. $obj->id.');" id="addNew-'.$obj->id.'">
					'.JText::_('Add new').'
					</a> <span id="loading-'.$obj->id.'"></span>';
			
		}
		?>
<script type="text/javascript">
			  function formatFloat(id)
			  {
			      var cur = document.getElementById(id).value;
			      reg = /[^\d\.]+/;
			      cur = cur.replace(',', '.');
			      cur = cur.replace('..', '.');
			      cur = cur.replace(reg, '');
			      document.getElementById(id).value = cur;
			  }
			  function formatInt(id)
				{
					var cur = document.getElementById(id).value;
					reg = /[^\d]+/;
					cur = cur.replace(reg, "");
					document.getElementById(id).value = cur;
				}
			  <?php 
			  if ($params->get('allow_extra', 0)) { 
			  ?>
			  
			  var lastCount = <?php echo $i; ?>;
			  var max = <?php echo ($params->get('allow_extra', 0) ? $params->get('max_extra', 0) : 0); ?>;
			  
			  function addNew(id)
			  {			  	
			  	var extra = document.getElementsByName('extra');	
			  	
			  	var out1 = '<input type="text" name="extra[' + id + '][title][' + lastCount + ']" style="width: 95%;" class="inputbox">';
				var out2 = '<input type="text" name="extra[' + id + '][min_amount][' + lastCount + ']" size="5" class="inputbox" id="extra' + id + '_amount' + lastCount + '" onkeyUp="formatInt(this.id)">';
				var out3 = '<input type="text" name="extra[' + id + '][price][' + lastCount + ']"  size="15" class="inputbox" id="extra' + id + '_price' + lastCount + '" onkeyUp="formatFloat(this.id)">';
				var out4 = '<a href="javascript:void(0);" onclick="removeItem(' + id + ', ' + lastCount + ');">Remove</a>';
				
				var elem = document.createElement("tr");
				elem.setAttribute("id", "option"+ lastCount);
				
				
				var elem1 = document.createElement("td");
				elem1.innerHTML = out1;
				var elem2 = document.createElement("td");
				elem2.innerHTML = out2;
				var elem3 = document.createElement("td");
				elem3.innerHTML = out3;
				var elem4 = document.createElement("td");
				elem4.innerHTML = out4;
				
				elem.appendChild(elem1);
				elem.appendChild(elem2);
				elem.appendChild(elem3);
				elem.appendChild(elem4);				 
				 
				document.getElementById('extra-' + id).appendChild(elem);	
				
			  	lastCount ++;
				
			  	if(max > 0 && lastCount >= max )
			  	document.getElementById('addNew-' + id).style.display = 'none';			  		
			}
			
			function removeItem(id, list_num)
			{
				var theDiv = document.getElementById('option' + list_num);
				if (theDiv)
				{
					document.getElementById('extra-' + id).removeChild(theDiv);
					lastCount -- ;
					if(max > 0 && lastCount < max)
					document.getElementById('addNew-' + id).style.display = null;
				}
			}
			 <?php } ?>
		</script>
			 <?php

			 require_once (JPATH_ROOT.DS.'components'.DS.'com_commerce'.DS.'helpers'.DS.'extensions.php');
			 $author = jcUser::getSeller($uid);
			 $percent = 0;
			 if($author->is_seller && $CP->get('comm_percentage'))
			 $percent = $CP->get('comm_percentage');
			 if($author->is_silver && $CP->get('comm_percentage_silver'))
			 $percent = $CP->get('comm_percentage_silver');
			 if($author->is_gold && $CP->get('comm_percentage_gold'))
			 $percent = $CP->get('comm_percentage_gold');
			 if($percent)
			 {
			 	echo '<span class="small">'.
			 	JText::_('You need assign the price with a glance of Shop Commission').' ('.$percent.'%)
					</span>
					<br>';
			 }
			 echo $out;

			 if ($params->get('allow_extra', 0))
			 {
			 	echo $extra_out;
			 }

	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'price') return;
		if(!$value) return;
		$db = & JFactory::getDBO();
		$user = JFactory::getUser();

		$secid = $row->id ? ResHelper::getArticleSection($row->id) :$params->get('section_id');
		$CP = ResHelper::getSectionParams($secid);

		$cur = JRequest::getInt("currency_id-".$id);
		$tax = JRequest::getInt("tax_id-".$id);
		$extra = JRequest::getVar('extra');

		$exval = '';
		if($cur != $CP->get('comm_core_currency') || $tax > 0 )
		{
			$exval = array('currency_id' => $cur, 'tax_id' => $tax ) ;
		}
		if(isset($extra[$id]))
		{
			$extra = $extra[$id];
			$i = 0;
			foreach ($extra['price'] as $k => $eval)
			{
				if($extra['title'][$k] == '' || $extra['min_amount'][$k] == '' || $extra['price'][$k] == '') continue;
				$extr['title'][$i] = $extra['title'][$k];
				$extr['min_amount'][$i] = $extra['min_amount'][$k];
				$extr['price'][$i] = $extra['price'][$k];
				$i ++;

			}
			if($exval != '')
			$exval = array_merge($exval, array('extra' => $extr));
			else
			$exval = array('extra' => $extr);
		}
		if($exval != '')
		$exval = serialize($exval);

		$sql = "SELECT id FROM #__js_res_field_extra WHERE field_id = '$id' AND record_id = '{$row->id}' AND ref_id = 'price_ext'";
		$db->setQuery($sql);
		if($exid = $db->loadResult())
		{
			$sql = "UPDATE #__js_res_field_extra SET value = '$exval' WHERE field_id = '$id' AND record_id = '{$row->id}' AND ref_id = 'price_ext'";
		}
		else
		{
			$sql = "INSERT INTO #__js_res_field_extra (`id`, `user_id`, `ref_id`, `ctime`, `ip`, `value`, `field_id`, `record_id`, `field_value_id`)
			VALUES
			('', '{$user->id}', 'price_ext', NOW(), '', '$exval', '$id', '{$row->id}', '')";
		}
		$db->setQuery($sql);
		$db->query();
		$price = $value;
		$this->convertPrice($price, $cur, 'to_core',  $CP->get('comm_core_currency'), $secid);
		$value = $price;
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;		
	
		if($type != 'price') return;
		if(!$field->field_value) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;

		$catid = JRequest::getInt('category_id');
		$sid = ResHelper::getArticleSection($field->record_id);
		$secid = $catid ? ResHelper::getCategorySection($catid) : ($sid ? $sid : $params->get('section_id'));
		if(!$secid)
		{
			$out = JText::_('Sourse section is not selected in field plugin settings');
			return;
		}
		$CP = ResHelper::getSectionParams($secid);
		if(!$CP->get('comm_enabled', 0)) return;

		$db = JFactory::getDBO();

		$price_core = $field->field_value;
		$price = $price_core;
		$sql = "SELECT value FROM #__js_res_field_extra WHERE field_id = '{$field->fid}' AND record_id = '{$field->record_id}' AND ref_id = 'price_ext'";
		$db->setQuery($sql);
		if($extra = $db->loadResult())
		{
			$val = unserialize($extra);
			if(isset($val['currency_id']))
			$this->convertPrice($price, $val['currency_id'], 'from_core', $CP->get('comm_core_currency'), $secid);

		}
		if(isset($val['currency_id']) && $val['currency_id'] !=  $CP->get('comm_core_currency'))
		{
			$sql = "SELECT format FROM #__jc_users_currencies
			WHERE currency_id='{$val['currency_id']}'";
			$db->setQuery($sql);
			$format = $db->loadResult();
			if($format == '')
			$format = $CP->get('comm_layout_price');
			$sql = "SELECT IF(mark != '', mark, code) as mark FROM #__jc_currency WHERE id = '{$val['currency_id']}'";
		}
		else
		{
			$format = $CP->get('comm_layout_price');
			$sql = "SELECT IF(mark != '', mark, code) as mark FROM #__jc_currency WHERE id = '".$CP->get('comm_core_currency')."'";
		}
		$db->setQuery($sql);
		$mark = $db->loadResult();


		if ($params->get('use_tax') && isset($val) && isset($val['tax_id']))
		{
			$sql = "SELECT rate FROM #__jc_taxes WHERE id='{$val['tax_id']}' AND published = '1'";
			$db->setQuery($sql);
			$tax = $db->loadObject();
			if($tax){
				$price += $price * $tax->rate / 100;
			}
		}
		$out = str_replace(array("00", "Sign"), array(round($price, 2), $mark) , $format);

		if($params->get('show_in_core', 0) && ( isset($val['currency_id']) && $val['currency_id'] != $CP->get('comm_core_currency') ) )
		{
			$sql = "SELECT IF(mark != '', mark, code) as mark FROM #__jc_currency WHERE id = '".$CP->get('comm_core_currency')."'";
			$db->setQuery($sql);
			$core_mark = $db->loadResult();
			if ($params->get('use_tax') && isset($tax))
			{
				$price_core += $price_core * $tax->rate / 100;
			}
			$out .= ' ('.str_replace(array("00", "Sign"), array(round($price_core, 2), $core_mark) , $CP->get('comm_layout_price')).')';
		}

		$alert = '';
		if($params->get('tax-alert'))
		$alert = JText::_("Price is non-adjusted for taxation");

		if ($params->get('use_tax') && isset($val) && isset($val['tax_id']) && $params->get('tax-alert'))
		{
			$alert = JText::_("Price is adjusted for taxation");
		}
		$out .= '<br><span class="small">'.$alert.'</span>';

		if($params->get('allow_extra', 0))
		{
			if(isset($val['extra']))
			{
				$extra = $val['extra'];
				$out .= '<fieldset><legend><b>'.JText::_('Special offer').'</b></legend>';
				foreach ($extra['price'] as $k => $pr)
				{

					if($params->get('max_extra') && $k > $params->get('max_extra')) break;
					if($pr != '')
					{
						$out .= '<p>';
						if($params->get('show_extra_title', 1) && $extra['title'][$k] != '')
						$out .= '<b>'.$extra['title'][$k].'</b> ';
						$out .= $extra['min_amount'][$k].' '.($extra['min_amount'][$k] == 1 ? JText::_('unit') : JText::_('units')).': ';

						$price = $extra['price'][$k];
						if ($params->get('use_tax') && isset($tax) && $tax)
						$price += $price * $tax->rate / 100;

						switch($params->get('show_exprice_per', 'unit'))
						{
							case 'unit':
								$out .= str_replace(array("00", "Sign"), array(round($price, 2), $mark) , $format).
									' '.JText::_('per 1 unit');
								break;
							case 'units':
								$out .= str_replace(array("00", "Sign"), array(round($price * $extra['min_amount'][$k], 2), $mark) , $format);
								break;
							case 'units_unit':
								$out .= str_replace(array("00", "Sign"), array(round($price * $extra['min_amount'][$k], 2), $mark) , $format);

								$out .= ' ('.str_replace(array("00", "Sign"), array(round($price, 2), $mark) , $format).' '.JText::_('per 1 unit').')';
								break;
						}
						$out .= '<p>';
					}
				}
				$out .= '</fieldset>';
			}
		}
	}

	function onFilter($out, $type)
	{
		if($type != 'price') return;
		$out = true;
	}
	function onRenderFilter($get, &$filter, $params, $category)
	{
		global $mainframe, $option;

		$results = array();

		$if_commerce_exists = JPATH_ROOT.DS.'administrator/components/com_commerce/controllers'.DS.'config.php';
		if(file_exists($if_commerce_exists))
		{
			require_once ($if_commerce_exists);
			CommerceControllerConfig::initialyze();
		}

		$fparam = new JParameter($filter->params);
		$filters_type = $filter->type;
		if($filters_type != 'price') return;

		$get = false;

		$itemid = JRequest::getVar('Itemid');
		$db = & JFactory::getDBO();
		$where = getFilterWhere($params);

		switch ($params->get('filters_mode', 1))
		{
			case 1:
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				AND rc.catid = {$category} {$where}
				GROUP BY fv.field_value";
				break;
			case 3:
				$category = JRequest::getInt('category_id', $category);
				$ids = ResHelper::getCategoryChildrenIds($category);
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				AND rc.catid IN ({$ids}) {$where}
				GROUP BY fv.field_value";
				break;
			case 2:
				$sql = "SELECT fv.field_value AS value,
				CONCAT(fv.field_value, ' (', COUNT(r.id), ')') AS text
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				WHERE fv.field_id = {$filter->id} {$where}
				GROUP BY fv.field_value";
				break;
		}

		if($fparam->get('order_by')) $sql .= ' ORDER BY ' . $fparam->get('order_by');

		if(!key_exists($sql, $results))
		{
			$db->setQuery($sql);
			$get = $db->loadObjectList();
			$results[$sql] = $get;
		}
		else
		{
			$get = $results[$sql];
		}

		if(is_array($get))
		{
			foreach ($get AS $key => $val)
			{
				$get[$key]->value = base64_encode($val->value);
			}
		}

	}

	function convertPrice(&$price, $cur, $type, $core_cur, $section)
	{
		$db = JFactory::getDBO();
		if($cur != $core_cur )
		{
			$catid = (defined('COMM_SECTION_ID') ? COMM_SECTION_ID : JRequest::getInt('category_id'));
			$sql = "SELECT rate FROM #__jc_users_currencies WHERE currency_id = '$cur' AND section_id = '$section'";
			$db->setQuery($sql);
			if($rate = $db->loadResult())
			{
				$price = ($type == 'to_core') ? $price / $rate : $price * $rate;
			}
		}
	}

	function onGetItemPrice(&$price, $id, $item_amount, $get = 'core', $with_tax = true, $in_format = false)
	{
		$catid = ResHelper::getArticleSection($id);
		$CP = ResHelper::getSectionParams($catid);
		if(!$CP->get('comm_enabled', 0)) return;

		$db = & JFactory::getDBO();
		$sql = "SELECT v.field_value, v.field_id, f.params
			FROM #__js_res_record_values v
 		  	JOIN #__js_res_record r ON v.record_id = r.id 
 		  	JOIN #__js_res_fields f ON v.field_id = f.id
 		  	WHERE r.id = '".$id."' AND f.type='price'";
		$db->setQuery($sql);
		$field = $db->loadObject();
		$cur = $CP->get('comm_core_currency');
		$format = $CP->get('comm_layout_price');

		$sql = "SELECT value FROM #__js_res_field_extra WHERE field_id = '{$field->field_id}' AND record_id = '$id' AND ref_id = 'price_ext'";
		$db->setQuery($sql);
		$price = $field->field_value;
		if($extra = $db->loadResult())
		{
			$val = unserialize($extra);
			if($get == 'user' && isset($val['currency_id']) && $val['currency_id'] != $cur)
			{
				$sql = "SELECT uc.rate, uc.format
				FROM #__jc_users_currencies uc
				WHERE uc.currency_id = '{$val['currency_id']}'
				AND uc.section_id = ".$catid;
				$db->setQuery($sql);
				$currency = $db->loadObject();

				$price *= $currency->rate;
				$cur = $val['currency_id'];
				$format = $currency->format;
			}
			if(isset($val['extra']))
			{
				$position = -1;
				foreach ($val['extra']['min_amount'] as $key => $amount)
				{
					if($item_amount >= $amount)
					$position = $key;
				}
				if($position != -1)
				$price = $val['extra']['price'][$position];

				if($get == 'core')
				{
					if(isset($val['currency_id']) && $val['currency_id'] != $cur )
					{
						$sql = "SELECT uc.rate
						FROM #__jc_users_currencies uc
						WHERE uc.currency_id = '{$val['currency_id']}'
						AND uc.section_id = ".$catid;
						$db->setQuery($sql);
						$rate = $db->loadResult();
						$price = $price / $rate;
					}
				}
			}
			$params = new JParameter($field->params);
			if ($params->get('use_tax') && isset($val) && $val['tax_id'] && $with_tax)
			{
				$sql = "SELECT rate FROM #__jc_taxes WHERE id='{$val['tax_id']}' AND published = '1'";
				$db->setQuery($sql);
				$tax = $db->loadObject();
				if($tax){
					$price = round($price, 2);
					$price += round($price * $tax->rate / 100, 2);
				}
			}
		}
		if($in_format)
		{
			$sql = "SELECT IF(mark != '', mark, code) as mark FROM #__jc_currency WHERE id = '$cur'";
			$db->setQuery($sql);
			$mark = $db->loadResult();
			$price = str_replace(array("00", "Sign"), array(round($price, 2), $mark) , $format);
		}
		return $price;

	}

}
?>